## ros-galactic-libpointmatcher 1.3.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

include(CheckSymbolExists)
include(GNUInstallDirs) # populate CMAKE_INSTALL_{LIB,BIN}DIR

#========================
# Project details / setup
#========================

set(CMAKE_POSITION_INDEPENDENT_CODE ON) # add -fPIC as required

# Extract version from header, done first to satisfy CMP0048,
# see `cmake --help-policy CMP0048` for more information.
file(
	STRINGS                               # Read in a file to memory.
	pointmatcher/PointMatcher.h           # File to parse for version number.
	POINTMATCHER_PROJECT_VERSION          # Where to store the results (should just be one line)
	REGEX "#define POINTMATCHER_VERSION " # The space after is important to ignore 'POINTMATCHER_VERSION_INT'
)
# If no matches found, something is wrong with PointMatcher.h
if (NOT POINTMATCHER_PROJECT_VERSION)
	message(SEND_ERROR "Cannot find version number in '${CMAKE_CURRENT_SOURCE_DIR}/pointmatcher/PointMatcher.h'.")
endif ()
# Transform '#define POINTMATCHER_VERSION "X.Y.Z"' into 'X.Y.Z'
string(REGEX REPLACE ".*\"(.*)\".*" "\\1" POINTMATCHER_PROJECT_VERSION "${POINTMATCHER_PROJECT_VERSION}")

# In 3.0+, project(...) should specify VERSION to satisfy CMP0048
if (CMAKE_VERSION VERSION_LESS 3.0.0)
	project(libpointmatcher)
else ()
	cmake_policy(SET CMP0048 NEW)
	project(libpointmatcher VERSION ${POINTMATCHER_PROJECT_VERSION})
endif ()


# Check if 32 bit platform
# By default, libpointmatcher is not compatible with and will not build on a
# 32 bit system
if( NOT CMAKE_SIZEOF_VOID_P EQUAL 8 )
    MESSAGE(SEND_ERROR "32 bits compiler detected. Libpointmatcher is only supported in 64 bits." )
    SET( EX_PLATFORM 32 )
    SET( EX_PLATFORM_NAME "x86" )
endif()

## WARNING: unsupported
## To force install as a 32 bit library, set BUILD_32 to true
if( BUILD_32 )
	MESSAGE(STATUS "Building as a 32 bit library")
	SET(CMAKE_CXX_FLAGS "-m32")
endif()

# Ensure proper build type
if (NOT CMAKE_BUILD_TYPE)
  message("-- No build type specified; defaulting to CMAKE_BUILD_TYPE=Release.")
  set(CMAKE_BUILD_TYPE Release CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
    FORCE)
else ()
  if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    message("\n=================================================================================")
    message("\n-- Build type: Debug. Performance will be terrible!")
    message("-- Add -DCMAKE_BUILD_TYPE=Release to the CMake command line to get an optimized build.")
    message("\n=================================================================================")
  endif ()
endif ()


#================= extra building definitions ==============================
if (NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
  add_definitions(-O3)
endif()

# For Windows
if( MSVC )
	add_definitions( /D _VARIADIC_MAX=10 ) # VS2012 does not support tuples correctly yet
	add_definitions( /D _USE_MATH_DEFINES) # defines M_PI for Visual Studio
	add_definitions( /D _ENABLE_EXTENDED_ALIGNED_STORAGE) # this variable must be defined with VS2017 to acknowledge alignment changes of aligned_storage
endif()

#======================= installation =====================================

# Offer the user the choice of overriding the installation directories
set(INSTALL_LIB_DIR lib CACHE PATH "Installation directory for libraries")
set(INSTALL_BIN_DIR bin CACHE PATH "Installation directory for executables")
set(INSTALL_INCLUDE_DIR include CACHE PATH
  "Installation directory for header files")
if(WIN32 AND NOT CYGWIN)
	set(DEF_INSTALL_CMAKE_DIR CMake)
else()
	set(DEF_INSTALL_CMAKE_DIR lib/cmake/pointmatcher)
endif()
set(INSTALL_CMAKE_DIR ${DEF_INSTALL_CMAKE_DIR} CACHE PATH "Installation directory for CMake files")


# Make relative paths absolute (needed later on)
foreach(p LIB BIN INCLUDE CMAKE)
	set(var INSTALL_${p}_DIR)
	if(NOT IS_ABSOLUTE "${${var}}")
		set(${var} "${CMAKE_INSTALL_PREFIX}/${${var}}")
	endif()
endforeach()

#===========================================================================


#======================== External Dependencies ===============================

# initially
set(EXTERNAL_LIBS "")

# compile local version of gtest and yaml-cpp
add_subdirectory(contrib)

#---------------------------
# DEPENDENCY:  POSIX Threads
#---------------------------
find_package(Threads REQUIRED)
if (CMAKE_VERSION VERSION_LESS 3.1.0)
  set(EXTERNAL_LIBS ${EXTERNAL_LIBS} ${CMAKE_THREAD_LIBS_INIT})
else()
  set(EXTERNAL_LIBS ${EXTERNAL_LIBS} Threads::Threads)
endif()

#--------------------
# DEPENDENCY:  boost
#--------------------
find_package(Boost COMPONENTS thread filesystem system program_options date_time REQUIRED)
if (Boost_MINOR_VERSION GREATER 47)
	find_package(Boost COMPONENTS thread filesystem system program_options date_time chrono REQUIRED)
endif ()

#--------------------
# DEPENDENCY: eigen 3
#--------------------
find_path(EIGEN_INCLUDE_DIR NAMES signature_of_eigen3_matrix_library
  HINTS  ENV EIGEN3_INC_DIR
         ENV EIGEN3_DIR
  PATHS  Eigen/Core
         /usr/local/include
         /usr/include
  PATH_SUFFIXES include eigen3 eigen
  DOC "Directory containing the Eigen3 header files"
)

# Suppress Eigen's warning by adding it to the system's library
include_directories(SYSTEM "${EIGEN_INCLUDE_DIR}")

#TODO: this should be a more standard way
#find_package(Eigen3 REQUIRED)
#message("-- eigen3 , version ${EIGEN_VERSION}")



#--------------------
# DEPENDENCY: nabo
#--------------------
if (NOT TARGET nabo)
  # Find libnabo:
  find_package(libnabo REQUIRED PATHS ${LIBNABO_INSTALL_DIR})
  message(STATUS "libnabo found, version ${libnabo_VERSION} (include=${libnabo_INCLUDE_DIRS} libs=${libnabo_LIBRARIES})")
else()
  # libnabo already part of this project (e.g. as a git submodule)
  # (This, plus the use of cmake target properties in libnabo, will also
  # introduce the required include directories, flags, etc.)
endif()
# This cmake target alias will be defined by either: 
# a) libnabo sources if built as a git submodule in the same project than this library, or
# b) by libnabo-targets.cmake, included by find_package(libnabo) above.
set(libnabo_LIBRARIES libnabo::nabo)

#--------------------
# DEPENDENCY: OpenMP (optional)
#--------------------
set(USE_OPEN_MP FALSE CACHE BOOL "Set to TRUE to use OpenMP")
if (USE_OPEN_MP)
	find_package(OpenMP)
	if (OPENMP_FOUND)
		add_definitions(-fopenmp -DHAVE_OPENMP)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
		if (CMAKE_COMPILER_IS_GNUCC)
			set(EXTERNAL_LIBS ${EXTERNAL_LIBS} gomp)
    		message("-- OpenMP found, parallel computer enabled")
		endif()
	endif()
endif ()

#--------------------
# DEPENDENCY: OpenCL (optional)
#--------------------
set(USE_OPEN_CL "false" CACHE BOOL "Set to ON to look for OpenCL, if your libnabo was compiled with CL support")
if (USE_OPEN_CL)
	if (WIN32)
		find_library(OPENCL_LIBRARIES opencl64)
		if (!OPENCL_LIBRARIES)
			find_library(OPENCL_LIBRARIES opencl32)
		endif ()
	else ()
		find_library(OPENCL_LIBRARIES OpenCL ENV LD_LIBRARY_PATH)
	endif ()
	# if found, add
	if (OPENCL_LIBRARIES)
		set(EXTERNAL_LIBS ${EXTERNAL_LIBS} ${OPENCL_LIBRARIES})
    	message("-- openCL found, parallel computer enabled for kd-tree")
	endif ()
endif()


#--------------------
# DEPENDENCY: yaml-cpp (local or system, optional)
#--------------------
option(USE_SYSTEM_YAML_CPP "Use system version of yaml-cpp rather than one packaged with libpointmatcher" FALSE)

if(USE_SYSTEM_YAML_CPP)
    message(STATUS "Looking for yaml-cpp on system")
    find_path(yaml-cpp_INCLUDE_DIRS yaml-cpp/yaml.h
            /usr/local/include
    )
    find_library(yaml-cpp_LIBRARIES yaml-cpp PATHS
            /usr/local/lib
    )
    if(yaml-cpp_INCLUDE_DIRS AND yaml-cpp_LIBRARIES)
            set(yamlcpp_FOUND)
            message("-- yaml-cpp found, text-based configuration enabled")
    else()
            message("-- yaml-cpp not found, text-based configuration and related applications disabled")
    endif()
else()
        include_directories(contrib/yaml-cpp-pm/include)

#note: this is not working....
        #get_property(yaml-cpp-pm_INCLUDE TARGET yaml-cpp-pm PROPERTY INCLUDE_DIRECTORIES)
        #include_directories(${yaml-cpp-pm_INCLUDE})

        list(APPEND EXTERNAL_LIBS $<TARGET_FILE:yaml-cpp-pm>)
        list(APPEND EXTRA_DEPS yaml-cpp-pm)
        set(yamlcpp_FOUND)

        get_property(yaml-cpp-pm_VERSION TARGET yaml-cpp-pm PROPERTY VERSION)
        message("-- using built-in yaml-cpp, version ${yaml-cpp-pm_VERSION}")
        message("   -- text-based configuration enabled")
endif()


#--------------------
# DEPENDENCY: rt (optional)
#--------------------
# link rt support if POSIX timers are used
check_symbol_exists(_POSIX_TIMERS "unistd.h;time.h" POSIX_TIMERS)

#============================= end dependencies =================================


#========================== libpointmatcher itself ==============================

# Check the compiler version as we need full C++11 support.
if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
	# using Clang
	if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "3.3")
		message(WARNING, "Your clang compiler has version ${CMAKE_CXX_COMPILER_VERSION}, while only version 3.3 or later is supported")
	endif ()
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
	# using AppleClang
	if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "5.1")
		message(WARNING "Your XCode environment has version ${CMAKE_CXX_COMPILER_VERSION}, while only version 5.1 or later is supported")
	endif()
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
	# using GCC
	if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.8.2")
		message(WARNING, "Your g++ compiler has version ${CMAKE_CXX_COMPILER_VERSION}, while only version 4.8.2 or later is supported")
	endif ()
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
	# using MSVC
	if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "19.0.23506")
		message(WARNING "Your Microsoft Visual C++ compiler has version ${CMAKE_CXX_COMPILER_VERSION}, while only version MSVC 2015 Update 1+ or later is supported")
	endif()
endif ()

# enable C++11 support.
if (CMAKE_VERSION VERSION_LESS "3.1")
	if (MSVC)
		message(FATAL_ERROR, "CMake version 3.1 or later is required to compiler ${PROJECT_NAME} with Microsoft Visual C++")
	endif ()
	if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
		set (CMAKE_CXX_FLAGS "-std=c++0x ${CMAKE_CXX_FLAGS}")
	else ()
		set (CMAKE_CXX_FLAGS "-std=c++11 ${CMAKE_CXX_FLAGS}")
	endif ()
else ()
	set (CMAKE_CXX_STANDARD 11)
endif ()

# SOURCE

# Pointmatcher lib and install
set(POINTMATCHER_SRC
	pointmatcher/Logger.cpp
	pointmatcher/Exceptions.cpp
	pointmatcher/DataPoints.cpp
	pointmatcher/Matches.cpp
	pointmatcher/ICP.cpp
	pointmatcher/Registry.cpp
	pointmatcher/Registrar.cpp
	pointmatcher/DataPointsFilter.cpp
	pointmatcher/Matcher.cpp
	pointmatcher/OutlierFilter.cpp
	pointmatcher/ErrorMinimizer.cpp
	pointmatcher/Transformation.cpp
	pointmatcher/TransformationChecker.cpp
	pointmatcher/Inspector.cpp
	pointmatcher/IO.cpp
	pointmatcher/IOFunctions.cpp
	pointmatcher/Bibliography.cpp
	pointmatcher/Timer.cpp
	pointmatcher/Histogram.cpp
	pointmatcher/Parametrizable.cpp
	pointmatcher/LoggerImpl.cpp
	pointmatcher/MatchersImpl.cpp
	pointmatcher/OutlierFiltersImpl.cpp
	pointmatcher/TransformationsImpl.cpp
	pointmatcher/TransformationCheckersImpl.cpp
	pointmatcher/InspectorsImpl.cpp
#ErrorMinimizers
	pointmatcher/ErrorMinimizers/PointToPlane.cpp
	pointmatcher/ErrorMinimizers/PointToPlaneWithCov.cpp
	pointmatcher/ErrorMinimizers/PointToPoint.cpp
	pointmatcher/ErrorMinimizers/PointToPointWithCov.cpp
	pointmatcher/ErrorMinimizers/PointToPointSimilarity.cpp
	pointmatcher/ErrorMinimizers/Identity.cpp
#DataPointsFilters
	pointmatcher/DataPointsFilters/Identity.cpp
	pointmatcher/DataPointsFilters/RemoveNaN.cpp
	pointmatcher/DataPointsFilters/MaxDist.cpp
	pointmatcher/DataPointsFilters/MinDist.cpp
	pointmatcher/DataPointsFilters/BoundingBox.cpp
	pointmatcher/DataPointsFilters/MaxQuantileOnAxis.cpp
	pointmatcher/DataPointsFilters/MaxDensity.cpp

=== python/CMakeLists.txt ===
if("${PYTHON_INSTALL_TARGET}" STREQUAL "")
	message(STATUS "PYTHON_INSTALL_TARGET variable is not set, setting a default value...")
	execute_process(COMMAND "python3" "-c" "import site; print(site.getsitepackages()[0])"
	                OUTPUT_VARIABLE PYTHON_INSTALL_TARGET OUTPUT_STRIP_TRAILING_WHITESPACE)
endif()

message(STATUS "The Python module will be install at this location : ${PYTHON_INSTALL_TARGET}")

set(PYBIND11_SOURCES
    #pointmatcher module
    pointmatcher/data_points.cpp
    pointmatcher/data_points_filter.cpp
    pointmatcher/data_points_filters.cpp
    pointmatcher/error_minimizer.cpp
    pointmatcher/icp.cpp
    pointmatcher/icp_chain_base.cpp
    pointmatcher/icp_sequence.cpp
    pointmatcher/impls/inspectors_impl.cpp
    pointmatcher/impls/matchers_impl.cpp
    pointmatcher/impls/outlier_filters_impl.cpp
    pointmatcher/impls/transformations_impl.cpp
    pointmatcher/impls/transformation_checkers_impl.cpp
    pointmatcher/impl.cpp
    pointmatcher/inspector.cpp
    pointmatcher/io.cpp
    pointmatcher/matcher.cpp
    pointmatcher/matches.cpp
    pointmatcher/outlier_filter.cpp
    pointmatcher/outlier_filters.cpp
    pointmatcher/point_matcher.cpp
    pointmatcher/transformation.cpp
    pointmatcher/transformations.cpp
    pointmatcher/transformation_checker.cpp
    pointmatcher/transformation_checkers.cpp

    #pointmatchersupport module
    pointmatchersupport/bibliography.cpp
    pointmatchersupport/logger.cpp
    pointmatchersupport/logger_impl.cpp
    pointmatchersupport/parametrizable.cpp
    pointmatchersupport/registrars/data_points_filter_registrar.cpp
    pointmatchersupport/registrars/error_minimizer_registrar.cpp
    pointmatchersupport/registrars/inspector_registrar.cpp
    pointmatchersupport/registrars/logger_registrar.cpp
    pointmatchersupport/registrars/matcher_registrar.cpp
    pointmatchersupport/registrars/outlier_filter_registrar.cpp
    pointmatchersupport/registrars/transformation_registrar.cpp
    pointmatchersupport/registrars/transformation_checker_registrar.cpp
    pointmatchersupport/registrar.cpp

    #errorminimizers module
    errorminimizers/identity.cpp
    errorminimizers/point_to_plane.cpp
    errorminimizers/point_to_plane_with_cov.cpp
    errorminimizers/point_to_point.cpp
    errorminimizers/point_to_point_similarity.cpp
    errorminimizers/point_to_point_with_cov.cpp

    #datapointfilters module
    datapointsfilters/bounding_box.cpp
    datapointsfilters/covariance_sampling.cpp
    datapointsfilters/cut_at_descriptor_threshold.cpp
    datapointsfilters/distance_limit.cpp
    datapointsfilters/ellipsoids.cpp
    datapointsfilters/fix_step_sampling.cpp
    datapointsfilters/gestalt.cpp
    datapointsfilters/identity.cpp
    datapointsfilters/incidence_angle.cpp
    datapointsfilters/max_density.cpp
    datapointsfilters/max_pointcount.cpp
    datapointsfilters/max_quantile_on_axis.cpp
    datapointsfilters/normal_space.cpp
    datapointsfilters/observation_direction.cpp
    datapointsfilters/octree_grid.cpp
    datapointsfilters/orient_normals.cpp
    datapointsfilters/random_sampling.cpp
    datapointsfilters/remove_nan.cpp
    datapointsfilters/remove_sensor_bias.cpp
    datapointsfilters/sampling_surface_normal.cpp
    datapointsfilters/shadow.cpp
    datapointsfilters/simple_sensor_noise.cpp
    datapointsfilters/sphericality.cpp
    datapointsfilters/surface_normal.cpp

    modules/point_matcher_module.cpp
    modules/point_matcher_support_module.cpp
    modules/data_points_filters_module.cpp
    modules/error_minimizers_module.cpp

    # main module
    pypoint_matcher.cpp)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_SOURCE_DIR}/pointmatcher
                    ${CMAKE_SOURCE_DIR}/pointmatcher/DataPointsFilters
                    ${CMAKE_SOURCE_DIR}/pointmatcher/DataPointsFilters/utils
                    ${CMAKE_SOURCE_DIR}/pointmatcher/ErrorMinimizers)

if(USE_SYSTEM_PYBIND11)
	find_package(pybind11 2.5.0 REQUIRED)
	message(STATUS "pybind11 v${pybind11_VERSION}")
else()
	add_subdirectory(pybind11)
	set(pybind11_FOUND TRUE)
endif()

if(pybind11_FOUND)
	pybind11_add_module(pypointmatcher ${PYBIND11_SOURCES})

	target_link_libraries(pypointmatcher
	                      PUBLIC
	                      pointmatcher)

	add_dependencies(pypointmatcher pointmatcher)

	install(TARGETS pypointmatcher LIBRARY DESTINATION ${PYTHON_INSTALL_TARGET})
else()
	message(FATAL_ERROR "pybind11 is required! Please follow the \"Compiling \
libpointmatcher's with Python\" instructions from the official libpointmatcher's documentation.")
endif()

=== utest/CMakeLists.txt ===

include_directories(../contrib/gtest)
add_executable(utest 
                utest.cpp 
                ui/IO.cpp 
                ui/DataFilters.cpp 
                ui/Matcher.cpp 
                ui/Outliers.cpp 
                ui/ErrorMinimizers.cpp 
                ui/Transformations.cpp 
                ui/DataPoints.cpp 
                ui/Inspectors.cpp 
                ui/Loggers.cpp)

find_package (Threads)
target_link_libraries(utest gtest pointmatcher ${CMAKE_THREAD_LIBS_INIT})

add_test(utest ${CMAKE_CURRENT_BINARY_DIR}/utest --path "${CMAKE_SOURCE_DIR}/examples/data/")

=== debian/changelog ===
ros-galactic-libpointmatcher (1.3.1-1focal) focal; urgency=high

  * Added documentation for people using ROS.
  * Increased libnabo minimal version to 1.0.7.
  * Added interface to inform if maximum number of iterations was reached.
  * Fixed portability issue of the FileLogger.
  * Fixed unit tests on Windows.
  * Fixed parameter-less modules having 'unknown' as class name.
  * Updated Windows compilation tutorial.
  * Fixed compilation problems on Windows.
  * Fixed PointToPlan error residual.
  * Changed DOI resolver link in documentation.
  * Added validation for the input transformation matrix in ICP.cpp.
  * Removed duplication of PointToPoint compute in PointToPointWithCov.
  * Added the RemoveSensorBias filter.
  * Splitted ErrorMinimizersImpl.cpp into multiple files.

 -- Francois Pomerleau <f.pomerleau@gmail.com>  Sun, 03 Mar 2019 23:00:00 -0000

ros-galactic-libpointmatcher (1.3.0-1focal) focal; urgency=high

  * Removed some boost utilities supported by c++11
  * Replaced raw pointers by std smart pointers

 -- Francois Pomerleau <f.pomerleau@gmail.com>  Thu, 25 Oct 2018 22:00:00 -0000

ros-galactic-libpointmatcher (1.2.4-1focal) focal; urgency=high

  * Support of Eigen 3.3
  * Introduced SurfaceNormalDataPointsFilter, OctreeGridDataPointsFilter and NormalSpaceDataPointsFilter
  * A lot of bugs were fixed

 -- Francois Pomerleau <f.pomerleau@gmail.com>  Sun, 14 Oct 2018 22:00:00 -0000

ros-galactic-libpointmatcher (1.2.3-1focal) focal; urgency=high

  * Support including other versions of YAML in compilation units that also include the YAML version packed with libpointmatcher (PR #80)
  * Changed immutability concept for SupportLabel to support MSVC 2012 (#78)
  * Fixed build system related bugs (#79, #70, ..).
  * updated build_map example, added better error message, added better information prints
  * cleaned CMakeList and added missing dependencies for external projetcs
  * avoid possibility of building dynamic library on MacOS
  * updated Mac build instructions
  * Tim3xx laser support on Simple Noise filter (#64)
  * Modified default covariance return in PointToPlaneWithCovErrorMinimizer (#59)
  * update usage text and retab
  * Removed compilation warnings
  * add unit test for ICPSequence
  * added application of reference data points filters for ICPSequence objects (#56)
  * Merge branch 'master' of github.com:ethz-asl/libpointmatcher
  * fix problem with libnabo linking (#54)
  * Adapted the code to handle 2D point clouds and decided to split the initial/icp/complete transformation matrices in 3 different files. It should be easier to post process the transformations.
  * Changed matrix for matrices as output suffix
  * Changed the ICP example (pmicp) to accept initial translation/rotation input and allow to output the transformation matrices
  * CutBelowLevelDataPointsFilter (PR #48)
  * split unit tests (PR #47)
  * Delete roadmap.txt
  * change year to 2014
  * correct bug in DataPoints operator==
  * add a method to remove features or descriptors
  * add empty function for removing features and descriptors
  * add functions to DataPoints avoiding error on rows and cols
  * fill missing documentation
  * resolve warning from unsigned to int in IO.cpp
  * add extra empty line in utest
  * add extra unit tests and resolve remaining bugs
  * Refactored how to load PLY files
  * Allow 2D descriptors (##45)
  * Allow saving 2D descriptors coming from a 2Dmap, that are converted to 3D when writing to the file but needed after if we want to load the map as 2D.
  * Contributors: Francis Colas, Francisco J Perez Grau, François Pomerleau, HannesSommer, Philipp Kruesi, Renaud Dube, Simon Lynen, chipironcin, pomerlef, smichaud, v01d

 -- Francois Pomerleau <f.pomerleau@gmail.com>  Thu, 14 May 2015 22:00:00 -0000

ros-galactic-libpointmatcher (1.2.2-1focal) focal; urgency=high

  * Yaml-cpp0.3 now built with libpointmatcher for compatibility with newer Ubuntu systems using yaml-cpp0.5

 -- Francois Pomerleau <f.pomerleau@gmail.com>  Mon, 04 Aug 2014 22:00:00 -0000

=== debian/control ===
Source: ros-galactic-libpointmatcher
Section: misc
Priority: optional
Maintainer: Francois Pomerleau <f.pomerleau@gmail.com>
Build-Depends: debhelper (>= 9.0.0), cmake, libboost-all-dev, libeigen3-dev, ros-galactic-libnabo, ros-galactic-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-galactic-libpointmatcher
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libeigen3-dev, ros-galactic-libnabo, ros-galactic-ros-workspace
Description: libpointmatcher is a modular ICP library, useful for robotics and computer vision.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/galactic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/galactic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/galactic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-galactic-libpointmatcher//opt/ros/galactic/lib/:$(CURDIR)/debian/ros-galactic-libpointmatcher//opt/ros/galactic/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_install
